/*

DrvFltlIp.h

Copyright (C) 2004 J.R. Jordan Wilberding

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or (at your option) 
any later version. This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
details. You should have received a copy of the GNU General Public License along 
with this program; if not, write to the Free Software Foundation, Inc., 675 Mass 
Ave, Cambridge, MA 02139, USA.

diginux@diginux.net

*/


#define FILE_DEVICE_DRVFLTIP  0x00654322


#define DRVFLTIP_IOCTL_INDEX  0x830


#define START_IP_HOOK CTL_CODE(FILE_DEVICE_DRVFLTIP, DRVFLTIP_IOCTL_INDEX,METHOD_BUFFERED, FILE_ANY_ACCESS)
#define STOP_IP_HOOK CTL_CODE(FILE_DEVICE_DRVFLTIP, DRVFLTIP_IOCTL_INDEX+1, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define ADD_FILTER CTL_CODE(FILE_DEVICE_DRVFLTIP, DRVFLTIP_IOCTL_INDEX+2, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define CLEAR_FILTER CTL_CODE(FILE_DEVICE_DRVFLTIP, DRVFLTIP_IOCTL_INDEX+3, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef struct filter
{
  USHORT protocol;

  ULONG sourceIp;	
  ULONG destinationIp;	

  ULONG sourceMask;	
  ULONG destinationMask;

  USHORT sourcePort;
  USHORT destinationPort;
	
  BOOLEAN drop;
}IPFilter, *PIPFilter;

struct filterList
{
  IPFilter ipf;
  struct filterList *next;
};


typedef struct IPHeader 
{
  UCHAR     iphVerLen;      
  UCHAR     ipTOS;         
  USHORT    ipLength;       
  USHORT    ipID;		      
  USHORT    ipFlags;	      
  UCHAR     ipTTL;	      
  UCHAR     ipProtocol;	   
  USHORT    ipChecksum;     
  ULONG     ipSource;      
  ULONG     ipDestination; 
} IPPacket, *PIPPacket; 

typedef struct _TCPHeader
{
  USHORT			sourcePort;		
  USHORT			destinationPort;
  ULONG			sequenceNumber;		
  ULONG			acknowledgeNumber;
  UCHAR			dataoffset;			
  UCHAR			flags;			
  USHORT			windows;			
  USHORT			checksum;		
  USHORT			urgentPointer;
} TCPHeader, *PTCPHeader;


typedef struct _UDPHeader
{
  USHORT			sourcePort;	
  USHORT			destinationPort;
  USHORT			len;
  USHORT			checksum;
} UDPHeader, *PUDPHeader;


